using Toybox.Application as App;
using Toybox.Background;
using Toybox.System as Sys;
using Toybox.WatchUi as Ui;
using Toybox.Time as Time;

var bgData=null;
var myreturns=0;

(:background)
class bgwfApp extends App.AppBase {
	var inBackground=false;
	var myKey="bgdata";	
    
    function initialize() {
        AppBase.initialize();
    	var now=Sys.getClockTime();
    	var ts=now.hour+":"+now.min.format("%02d");
    	//you'll see this gets called in both the application and background        
        Sys.println("App initialize "+ts);
        //read what's in storage
        bgData=Application.Storage.getValue(myKey);  
    }

    // onStart() is called on application or background start up
    function onStart(state) {  
    }

    // onStop() is called when your application or background is exiting
    function onStop(state) {
    	if(!inBackground) {
    		//only for the application and not background
	    	var now=Sys.getClockTime();
    		var ts=now.hour+":"+now.min.format("%02d");           
    	}
    }

    // Return the initial view of your application here
    function getInitialView() {
		//register for temporal events if they are supported
    	if(Toybox.System has :ServiceDelegate) {
    		Background.registerForTemporalEvent(new Time.Duration(5 * 60));
    	} else {
    		Sys.println("****background not available on this device****");
    	}
        return [ new bgwfView() ];
    }
    
    function onBackgroundData(data) {
    	myreturns++;
    	var now=Sys.getClockTime();
    	var ts=now.hour+":"+now.min.format("%02d");
        Sys.println("onBackgroundData="+data+" at "+ts);
        bgData=data;
        Application.Storage.setValue(myKey,bgData);
        Ui.requestUpdate();
    }    

    function getServiceDelegate(){
    	//only called in the background	
    	var now=Sys.getClockTime();
    	var ts=now.hour+":"+now.min.format("%02d");    
    	Sys.println("getServiceDelegate: "+ts);
    	inBackground=true;
        return [new BgBLE.BLEServiceDelegate()];
    }
}