using Toybox.WatchUi as Ui;
using Toybox.Graphics as Gfx;
using Toybox.System as Sys;
using Toybox.Lang as Lang;
using Toybox.Application as App;

class bgwfView extends Ui.WatchFace {

	var width,height;
	var degree="°";	//utf-8, b0 hex, 176 dec

    function initialize() {
        WatchFace.initialize();      
    }

    // Load your resources here
    function onLayout(dc) {
        width=dc.getWidth();
        height=dc.getHeight();
     }

    // Called when this View is brought to the foreground. Restore
    // the state of this View and prepare it to be shown. This includes
    // loading resources into memory.
    function onShow() {
    }

    // Update the view
    function onUpdate(dc) {
        // Get and show the current time
        var now=Time.now();
        var clockTime=Time.Gregorian.info(now,Time.FORMAT_SHORT);
        var timeString = Lang.format("$1$:$2$", [clockTime.hour, clockTime.min.format("%02d")]);
		var lastbg="?";
		var lastTime=Background.getLastTemporalEventTime();
		if(lastTime!=null) {
			var span=now.value()-lastTime.value();
			lastbg=toHMS(span);			
		}
		
		dc.setColor(Gfx.COLOR_BLACK,Gfx.COLOR_BLACK);
		dc.clear();
		dc.setColor(Gfx.COLOR_WHITE,Gfx.COLOR_TRANSPARENT);
		
		dc.drawText(width/2,25,Gfx.FONT_SMALL,timeString,Gfx.TEXT_JUSTIFY_CENTER);
		
		dc.drawText(width/2,55,Gfx.FONT_SMALL,"new data "+myreturns+" times",Gfx.TEXT_JUSTIFY_CENTER);

		dc.drawText(width/2,80,Gfx.FONT_SMALL,"last BG: "+lastbg,Gfx.TEXT_JUSTIFY_CENTER);
		
		dc.drawText(width/2,110,Gfx.FONT_SMALL,"Thingy Data",Gfx.TEXT_JUSTIFY_CENTER);
		
		var data=(bgData==null) ? "-none-" : ""+bgData[0]+degree+" "+bgData[1]+"%";		
		
		var age="?";
		if(bgData!=null && bgData.size()>2) {
			age=toHMS(Time.now().value()-bgData[2]);	
		}		
		
		dc.drawText(width/2,140,Gfx.FONT_SMALL,data+"\nAge: "+age,Gfx.TEXT_JUSTIFY_CENTER);

    }
    
    function toHMS(secs) {
    	var hr = secs/3600;
    	var min = (secs-(hr*3600))/60;
    	var sec = secs%60;
    	if(hr==0) {
    		return min.format("%02d")+":"+sec.format("%02d");
    	} else {
    		return hr.format("%02d")+":"+min.format("%02d")+":"+sec.format("%02d");
    	}
    }    

    // Called when this View is removed from the screen. Save the
    // state of this View here. This includes freeing resources from
    // memory.
    function onHide() {
    }

    // The user has just looked at their watch. Timers and animations may be started here.
    function onExitSleep() {
    }

    // Terminate any active timers and prepare for slow updates.
    function onEnterSleep() {
    }

}
